*============================================================================
* I/O driver for PROMICE virtual serial port (ROMART).
* VER 2.0A
* Module Name:  aidrv.inc
* Module Desc:  include file (as hwdrv.inc) for board.src or moto.src
* Created:      MAY 1994
* Author:       ARVIND RANA
*
* "PROMICE" and "ROMART" are trademarks (TM) of Grammar Engine, Inc.
* Portions copyright (c) 1993,94  Grammar Engine, Inc.
* Portions copyright (c) 1991 Microtec Research, Inc.
* All rights reserved
*============================================================================

	IFNE	CONIO&INITIO

IO_INIT:
	MOVE.L	A0,-(SP)	; save reg
	LEA	AILOC,A0	; address of AILOC
AIINIT:
	CMPI.B	#$CC,AISTS(A0)	; is status is $CC
	BEQ.S	AIINIT		; then still reading ROM
	TST.B	AIDATA(A0)	; read the bogus character
	
	IFNE	CONIO&INTRPT    ; polling doesn't enable interrupt on RX

	IFNE	TARGET&(CPU68000+CPU68070)
	SUBA.L	A0,A0           ; A0->IVT
	ELSEC
	MOVEC.L	VBR,A0         ; A0->IVT
	ENDC
	MOVE.L	#RX_INT,IOINTVECT*4(A0)   ; set to point to rcv int
	ENDC			; INTRPT

*	LOOPBACK test - comment out the lines below for loopback test
*	if you are using interrupt only mode also enable compiliation of
*	CON_IN routine for loop back to work

AILOOP:
*	BSR	CON_IN		; read user input
*	CMP.L	#ER_NCA,D0	; any input?
*	BEQ.B	AILOOP		; not yet
*	ADDQ.L	#1,D1		; increment by one
*	BSR	CON_OUT		; spit it back out
*	BRA	AILOOP		; keep at it

*	end of loopback test code

	MOVE.L	(SP)+,A0	; restore reg
	RTS

* Aux-mon routine stubs:

INIT_RESET:			;reset port from aux-mon (interrupt, etc)
	RTS

IO_TERM:			;reset port to aux-mon (disable int, etc)
	RTS

	ENDC			; INITIO

IO_BAUD:
	RTS

*-============================================================
* Polled output - send character to HOST over ROMART
*
*  -> D1 = character to transmit
*  <- D0 = RET_OK (transmitted ok)
*          ER_TBF (transmit buffer full)
*
*-============================================================

CON_OUT:
	MOVEM.L	D1/D2/A0,-(SP)	; save regs
	LEA	AILOC,A0		; AILOC address
AIPUT1:
	BTST.B	#ARTTDA,AISTS(A0)      ; TDA set?
	BNE.B	AIPUT1          ; not yet

	MOVE.L	#7,D0		; eight bits to send
	TST.B	AIONE(A0)	; start-bit
AIPUT2:
	BTST	#0,D1		; data bit 0 or 1?
	BEQ.B	AIPUT3		; send zero
	TST.B	AIONE(A0)	; else send one
	BRA.B	AIPUT4		; next bit
AIPUT3:
	TST.B	AIZERO(A0)	; send zero
AIPUT4:
	ROR	#1,D1		; next bit
	DBF	D0,AIPUT2	; do it
	TST.B	AIONE(A0)	; stop-bit

	MOVE.L	#RET_OK,D0	; success
	MOVEM.L	(SP)+,D1/D2/A0
	RTS

*-============================================================
* Polled input - receive a character from HOST (maybe)
*
*  <- D1 = received character
*     D0 = RET_OK (received ok)
*          ER_NCA (no character available)
*          ER_REC (receive error)
*
*	if doing AILOOP then comment out IFNE below and ENDC at end
*	of CON_IN for loop test to work correctly
*-============================================================

	IFNE	CONIO&POLLED

CON_IN:
	MOVE.L	A0,-(SP)	; save a reg
	LEA	AILOC,A0	; A5 - AILOC POINTER.
	BTST.B	#ARTHDA,AISTS(A0) ; Host data?
	BEQ.B	AIGETX		; none
	MOVE.B	AIDATA(A0),D1	; else read data
	MOVEQ.L	#RET_OK,D0	; Set rcvd ok.
	MOVE.L	(SP)+,A0
	RTS

AIGETX:
	MOVE.L	#ER_NCA,D0	; say not ready yet
	MOVE.L	(SP)+,A0
	RTS

	ENDC			; POLLED

	IFNE	CONIO&INTRPT

RX_INT:
	MOVEM.L	D0/D1/A0,-(SP)

	LEA	AILOC,A0	; A0 - AILOC POINTER.
	BTST.B	#ARTHDA,AISTS(A0) ; HOST DATA?
	BEQ.B	RX_INT_DONE	; bogus interrupt

	MOVE.B	AIDATA(A0),D1	; else read data
	MOVEQ.L	#RET_OK,D0	; Set rcvd ok.
	BSR	MO_START+MORXCHR ; Call monitor
	CMP.B	#ER_HLT,D0	; Return from monitor. All ok?
	BNE	RX_INT_DONE	; Yes.

	MOVEM.L	(SP)+,D0/D1/A0	; No - restore regs.
	BRA	MO_START+MOHALT	; Bad - stop.

RX_INT_ERR:
	MOVE.L	#ER_REC,D0	; tell them we lost a char
	BSR	MO_START+MORXCHR ; call monitor

RX_INT_DONE:
	MOVEM.L	(SP)+,D0/D1/A0
	RTE

	ENDC

*########################### END ###########################################
