*============================================================================
* I/O driver for PROMICE virtual serial port (ROMART).
* VER 2.0A
* Module Name:  AIEQU.INC
* Module Desc:  include file (as HWEQU.INC) for board.src
* Created:      MAY 1994
* Author:       ARVIND RANA
*
* "PROMICE" and "ROMART" are trademarks (TM) of Grammar Engine, Inc.
* Portions copyright (c) 1993,94  Grammar Engine, Inc.
* Portions copyright (c) 1991 Microtec Research, Inc.
* All rights reserved
*-===========================================================================
*****************************************************************************
* USER MUST define the bus width to indicate the bus width of the data      *
* bus that accesses the PROMICE emulated ROM space. It is specified as      *
* follows:                                                                  *
*                                                                           *
*       BYTE_WIDE for 8 bit wide data bus                                   *
*       WORD_WIDE for 16 bit wide data bus                                  *
*       LONG_WIDE for 32 bit wide data bus                                  *
*****************************************************************************
* Define it here:

WORD_WIDE:

*############################ BYTE_WIDE ###############################################

	IFDEF	BYTE_WIDE

*	AILOC is location of ROMART in the ROM space. It must be aligned to a 
*	4-byte boundary for proper operation

	ALIGN	4

AILOC:	DC.L    $CCCCCCCC ; AI comunication area


* ; AI - ROMART control area map

AIZERO	EQU	0	; read to send zero
AIONE	EQU	1	; read to send one
AIDATA	EQU	2	; read data from HOST
AISTS	EQU	3	; read interface status

	ENDC

*############################ WORD_WIDE ###############################################

	IFDEF   WORD_WIDE

*	AILOC is location of ROMART in the ROM space. It must be aligned to a 
*	8-byte boundary (i.e. lower three bits of address must be zero). This
*	will allow the location to be aligned to a 4-byte boundary within the
*	single ROM which is a must for proper operation. Since there is no
*	ALIGN command for the assembler for parameter larger than 4, this must
*	be done manually by padding DC.L 0's before the AILOC

	align	4

*	insert DC.L	0's here to ensure proper alignments

AILOC:	DC.L	$CCCCCCCC	; AI comunication area
	DC.L	$CCCCCCCC

*
* ; AI - ROMART control area map
*
AIZERO	EQU	0	; read to send zero
AIONE	EQU	2	; read to send one
AIDATA	EQU	4	; read data from HOST
AISTS	EQU	6	; read interface status

	ENDC

*############################ LONG_WIDE ###############################################

	IFDEF   LONG_WIDE

*	AILOC is location of ROMART in the ROM space. It must be aligned to a 
*	16-byte boundary (i.e. lower FOUR bits of address must be zero). This
*	will allow the location to be aligned to a 4-byte boundary within the
*	single ROM which is a must for proper operation. Since there is no
*	ALIGN command for the assembler for parameter larger than 4, this must
*	be done manually by padding DC.L 0's before the AILOC

	align	4

*	insert DC.L	0's here to ensure proper alignments

AILOC:	DC.L	$CCCCCCCC	; AI comunication area
	DC.L	$CCCCCCCC
	DC.L	$CCCCCCCC
	DC.L	$CCCCCCCC

*
* ; AI - ROMART control area map
*
AIZERO	EQU	0	; read to send zero
AIONE	EQU	4	; read to send one
AIDATA	EQU	8	; read data from HOST
AISTS	EQU	12	; read interface status

	ENDC

*############################################################################
*
*  ROMART status bits
*
ARTTDA	EQU	0	; Target Data Available
ARTHDA	EQU	1	; Host Data Available
	XDEF	AILOC
*============================= END ==========================================
